Leetcode 只出现一次的数字 II


也就是说,ones 和 twos 是若干个 位 并行更新的,相当于两个单独的0-1数组,twoi onei 组成当前位 i 的状态。由于只存在一个出现次数为 1 的数字,所以遍历完所有数字后,各二进制位的状态只可能处于 00 或 01 状态,不可能处于 10 状态,此时由于twos恒为0,所以我们可以用 ones 来返回最终的结果。

java 实现

java 复制代码
class Solution {
    public int singleNumber(int[] nums) {
        int ones = 0, twos = 0;
        for(int num:nums) {
            ones = (ones ^ num) & ~twos; //更新所有位状态的 one 
            twos = (twos ^ num) & ~ones; //更新所有位状态的 two 
        }
        return ones;
    }
}
相关推荐
Code_Solitude15 分钟前
传智杯备赛代码整理(前4题)
数据结构·算法
Jasmine_llq1 小时前
《P8816 [CSP-J 2022] 上升点列》
数据结构·算法·贪心·排序·二维动态规划 dp·类背包状态转移
hetao17338371 小时前
2026-10-19 hetao1733837 的刷题记录
c++·算法
辛苦才能1 小时前
C++ 哈希表深度解析:删除为什么必须打标记,负载因子为什么卡 0.7
开发语言·数据结构·c++·算法
m0_639906941 小时前
HashMap:哈希扰动、扩容源码、红黑树转换、并发问题
java·算法·哈希算法
冲冲那年1 小时前
项目整合管理
职场和发展
开开心心就好2 小时前
白天晚上自动调蓝光,护眼工具亮度可调
服务器·开发语言·算法·pdf·ocr·intellij-idea·idea
零售校长2 小时前
二七区零售门店店长面试,重点在哪几处
面试·职场和发展·零售
背景调查知识库3 小时前
职业背景调查中的异常复核与候选人说明如何识别?
职场和发展